/**
 *****************************************************************************
 * @file        CWUH20K1.h
 * 
 * @brief       Declaration of CWUH20K1. 
 * 
 * @author      Robert Jan Ridder
 * 
 * $Date: 2005/08/05 00:03:30 $
 * $Revision: 1.16 $
 * 
 * 
 *****************************************************************************
 * Copyright (C) Creative Technology, Ltd., 1999-2005. All rights reserved.
 *****************************************************************************
 */
#ifndef __CWUH20K1_h
#define __CWUH20K1_h

#include "C20KxPlugin.h"
#include "IPluginPort2.h"
#include "C20KxPluginPort.h"
#include "20KxPlugPropIds.h"
#include "I20KxPluginEngine.h"

#define MCH_MAX	8

interface I20KxPeDspProgramNode;  //forward reference

/** The plugin class. */
class CWUH20K1 : public C20KxPlugin
{

/*************************************************************************
 * @name COMMON METHODS
 *************************************************************************/  
//@{ 

protected:

	virtual STDMETHODIMP setParamValue(CTDWORD dwParam, PARAM_VALUE value);

//@}

public:

	CWUH20K1();
	~CWUH20K1();

protected:
	I20KxPeAudioBusNode     *m_pBusNode[2];
	I20KxPeAudioSendNode    *m_pSendNode[MCH_MAX+2];
	I20KxPeAudioScalerNode  *m_pDummyNode[MCH_MAX];
	I20KxPeAudioScalerNode  *m_pScalerNode[MCH_MAX];

private:
	CTBOOL  m_has_rear_center;			/**< Flag: zenith mode has Rear Center. */
	CTFLOAT	m_fsample;					/**< Actual sampling frequency at which plugin is loaded and running [Hz] */

	HRESULT rampScalerNodeLevel(I20KxPeAudioScalerNode  *pScalerNode, float dBGain);
	HRESULT rampScalerNodeLevels(float dBGain);
};

#endif //__CWUH20K1_h
